#ifndef RAY_HPP
#define RAY_HPP

#include <iostream>
#include "cuda.hpp"
#include "point.hpp"

struct Ray {
   Point origin;
   Vector direction;
   HOST_DEV Ray() : origin(0, 0, 0), direction(0, 0, 1) {
   }
   HOST_DEV Ray(const Point& origin, const Vector& direction) :
      origin(origin), direction(direction) {
   }
};

std::ostream& operator<<(std::ostream& out, const Ray& ray) {
   return out << "ray from " << ray.origin << " with direction " << ray.direction;
}

#endif
